import createPropertyDescriptor from './create-property-descriptor.js';
import objectCreate from './object-create.js';
import setToStringTag from './set-to-string-tag.js';
import iterators from './iterators.js';
import iteratorsCore from './iterators-core.js';

var IteratorPrototype = iteratorsCore.IteratorPrototype;





var returnThis = function () { return this; };

var createIteratorConstructor = function (IteratorConstructor, NAME, next) {
  var TO_STRING_TAG = NAME + ' Iterator';
  IteratorConstructor.prototype = objectCreate(IteratorPrototype, { next: createPropertyDescriptor(1, next) });
  setToStringTag(IteratorConstructor, TO_STRING_TAG, false);
  iterators[TO_STRING_TAG] = returnThis;
  return IteratorConstructor;
};

export default createIteratorConstructor;
