import classofRaw from './classof-raw.js';
import isObject from './is-object.js';
import wellKnownSymbol from './well-known-symbol.js';

var MATCH = wellKnownSymbol('match');

// `IsRegExp` abstract operation
// https://tc39.github.io/ecma262/#sec-isregexp
var isRegexp = function (it) {
  var isRegExp;
  return isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : classofRaw(it) == 'RegExp');
};

export default isRegexp;
