import descriptors from './descriptors.js';
import anObject from './an-object.js';
import objectDefineProperty from './object-define-property.js';
import objectKeys from './object-keys.js';

// `Object.defineProperties` method
// https://tc39.github.io/ecma262/#sec-object.defineproperties
var objectDefineProperties = descriptors ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = objectKeys(Properties);
  var length = keys.length;
  var index = 0;
  var key;
  while (length > index) objectDefineProperty.f(O, key = keys[index++], Properties[key]);
  return O;
};

export default objectDefineProperties;
