import descriptors from './descriptors.js';
import objectPropertyIsEnumerable from './object-property-is-enumerable.js';
import createPropertyDescriptor from './create-property-descriptor.js';
import toIndexedObject from './to-indexed-object.js';
import toPrimitive from './to-primitive.js';
import has from './has.js';
import ie8DomDefine from './ie8-dom-define.js';

var nativeGetOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// `Object.getOwnPropertyDescriptor` method
// https://tc39.github.io/ecma262/#sec-object.getownpropertydescriptor
var f = descriptors ? nativeGetOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
  O = toIndexedObject(O);
  P = toPrimitive(P, true);
  if (ie8DomDefine) try {
    return nativeGetOwnPropertyDescriptor(O, P);
  } catch (error) { /* empty */ }
  if (has(O, P)) return createPropertyDescriptor(!objectPropertyIsEnumerable.f.call(O, P), O[P]);
};

var objectGetOwnPropertyDescriptor = {
	f: f
};

export default objectGetOwnPropertyDescriptor;
export { f };
