import descriptors from './descriptors.js';
import objectDefineProperty from './object-define-property.js';
import getBuiltIn from './get-built-in.js';
import wellKnownSymbol from './well-known-symbol.js';

var SPECIES = wellKnownSymbol('species');

var setSpecies = function (CONSTRUCTOR_NAME) {
  var Constructor = getBuiltIn(CONSTRUCTOR_NAME);
  var defineProperty = objectDefineProperty.f;

  if (descriptors && Constructor && !Constructor[SPECIES]) {
    defineProperty(Constructor, SPECIES, {
      configurable: true,
      get: function () { return this; }
    });
  }
};

export default setSpecies;
