import global_1 from './global.js';
import has from './has.js';
import shared from './shared.js';
import uid from './uid.js';
import nativeSymbol from './native-symbol.js';
import useSymbolAsUid from './use-symbol-as-uid.js';

var WellKnownSymbolsStore = shared('wks');
var Symbol = global_1.Symbol;
var createWellKnownSymbol = useSymbolAsUid ? Symbol : Symbol && Symbol.withoutSetter || uid;

var wellKnownSymbol = function (name) {
  if (!has(WellKnownSymbolsStore, name)) {
    if (nativeSymbol && has(Symbol, name)) WellKnownSymbolsStore[name] = Symbol[name];
    else WellKnownSymbolsStore[name] = createWellKnownSymbol('Symbol.' + name);
  } return WellKnownSymbolsStore[name];
};

export default wellKnownSymbol;
