import _export from '../internals/export.js';
import addToUnscopables from '../internals/add-to-unscopables.js';
import arrayFill from '../internals/array-fill.js';

// `Array.prototype.fill` method
// https://tc39.github.io/ecma262/#sec-array.prototype.fill
_export({ target: 'Array', proto: true }, {
  fill: arrayFill
});

// https://tc39.github.io/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables('fill');
