import indexedObject from '../internals/indexed-object.js';
import toIndexedObject from '../internals/to-indexed-object.js';
import _export from '../internals/export.js';
import arrayMethodIsStrict from '../internals/array-method-is-strict.js';

var nativeJoin = [].join;

var ES3_STRINGS = indexedObject != Object;
var STRICT_METHOD = arrayMethodIsStrict('join', ',');

// `Array.prototype.join` method
// https://tc39.github.io/ecma262/#sec-array.prototype.join
_export({ target: 'Array', proto: true, forced: ES3_STRINGS || !STRICT_METHOD }, {
  join: function join(separator) {
    return nativeJoin.call(toIndexedObject(this), separator === undefined ? ',' : separator);
  }
});
