import _export from '../internals/export.js';
import arrayMethodIsStrict from '../internals/array-method-is-strict.js';
import arrayMethodUsesToLength from '../internals/array-method-uses-to-length.js';
import arrayIteration from '../internals/array-iteration.js';

var $some = arrayIteration.some;



var STRICT_METHOD = arrayMethodIsStrict('some');
var USES_TO_LENGTH = arrayMethodUsesToLength('some');

// `Array.prototype.some` method
// https://tc39.github.io/ecma262/#sec-array.prototype.some
_export({ target: 'Array', proto: true, forced: !STRICT_METHOD || !USES_TO_LENGTH }, {
  some: function some(callbackfn /* , thisArg */) {
    return $some(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  }
});
