import fails from '../internals/fails.js';
import _export from '../internals/export.js';
import toObject from '../internals/to-object.js';
import objectKeys from '../internals/object-keys.js';

var FAILS_ON_PRIMITIVES = fails(function () { objectKeys(1); });

// `Object.keys` method
// https://tc39.github.io/ecma262/#sec-object.keys
_export({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES }, {
  keys: function keys(it) {
    return objectKeys(toObject(it));
  }
});
