import global_1 from '../internals/global.js';
import createNonEnumerableProperty from '../internals/create-non-enumerable-property.js';
import arrayForEach from '../internals/array-for-each.js';
import domIterables from '../internals/dom-iterables.js';

for (var COLLECTION_NAME in domIterables) {
  var Collection = global_1[COLLECTION_NAME];
  var CollectionPrototype = Collection && Collection.prototype;
  // some Chrome versions have non-configurable methods on DOMTokenList
  if (CollectionPrototype && CollectionPrototype.forEach !== arrayForEach) try {
    createNonEnumerableProperty(CollectionPrototype, 'forEach', arrayForEach);
  } catch (error) {
    CollectionPrototype.forEach = arrayForEach;
  }
}
