import '../../node_modules/core-js/modules/es.object.to-string.js';
import '../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../node_modules/core-js/modules/es.regexp.to-string.js';
import classCallCheck from '../../node_modules/@babel/runtime/helpers/classCallCheck.js';
import createClass from '../../node_modules/@babel/runtime/helpers/createClass.js';
import inherits from '../../node_modules/@babel/runtime/helpers/inherits.js';
import possibleConstructorReturn from '../../node_modules/@babel/runtime/helpers/possibleConstructorReturn.js';
import getPrototypeOf from '../../node_modules/@babel/runtime/helpers/getPrototypeOf.js';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component, Vue } from 'vue-property-decorator';
import { Async, EventGroup, css } from '@uifabric-vue/utilities';
import { getTheme } from '@uifabric/styling';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var BaseComponent = /*#__PURE__*/function (_Vue) {
  inherits(BaseComponent, _Vue);

  var _super = _createSuper(BaseComponent);

  function BaseComponent() {
    var _this;

    classCallCheck(this, BaseComponent);

    _this = _super.apply(this, arguments);
    _this.componentRef = null;
    _this.css = css;
    _this.__async = null;
    _this.__events = null;
    _this.__disposables = null;
    _this.state = {};
    _this.props = {};
    return _this;
  } // created () {
  //   for (const key in this.$props) {
  //     if (this.$props.hasOwnProperty(key)) {
  //       this.$set(this.props as any, key, this.$props[key])
  //     }
  //   }
  // }

  /**
   * When the component has mounted, update the componentRef.
   */


  createClass(BaseComponent, [{
    key: "mounted",
    value: function mounted() {
      this.componentRef = this.$el;
    }
    /**
     * If we have disposables, dispose them automatically on unmount.
     */

  }, {
    key: "beforeDestroy",
    value: function beforeDestroy() {
      if (this.__disposables) {
        for (var i = 0, len = this._disposables.length; i < len; i++) {
          var disposable = this.__disposables[i];

          if (disposable.dispose) {
            disposable.dispose();
          }
        }

        this.__disposables = null;
      }
    }
  }, {
    key: "setState",

    /**
     * Updates the component's current state.
     *
     * @returns The updated state object.
     */
    value: function setState(newState) {
      for (var key in newState) {
        this.$set(this.state, key, newState[key]);
      }

      return this.state;
    }
  }, {
    key: "uid",
    get: function get() {
      // @ts-ignore
      return this._uid;
    }
  }, {
    key: "classNames",
    get: function get() {
      return {};
    }
    /**
     * Allows subclasses to push things to this._disposables to be auto disposed.
     */

  }, {
    key: "_disposables",
    get: function get() {
      if (!this.__disposables) {
        this.__disposables = [];
      }

      return this.__disposables;
    }
    /**
     * Gets the async instance associated with the component, created on demand. The async instance gives
     * subclasses a way to execute setTimeout/setInterval async calls safely, where the callbacks
     * will be cleared/ignored automatically after unmounting. The helpers within the async object also
     * preserve the this pointer so that you don't need to "bind" the callbacks.
     */

  }, {
    key: "_async",
    get: function get() {
      if (!this.__async) {
        this.__async = new Async(this);

        this._disposables.push(this.__async);
      }

      return this.__async;
    }
    /**
     * Gets the event group instance assocaited with the component, created on demand. The event instance
     * provides on/off methods for listening to DOM (or regular javascript object) events. The event callbacks
     * will be automatically disconnected after unmounting. The helpers within the events object also
     * preserve the this reference so that you don't need to "bind" the callbacks.
     */

  }, {
    key: "events",
    get: function get() {
      if (!this.__events) {
        this.__events = new EventGroup(this);

        this._disposables.push(this.__events);
      }

      return this.__events;
    }
  }]);

  return BaseComponent;
}(Vue);

__decorate([Prop({
  type: [String, Array],
  default: ''
}), __metadata("design:type", String)], BaseComponent.prototype, "className", void 0);

__decorate([Prop({
  type: [Object, Function],
  default: function _default() {}
}), __metadata("design:type", Object)], BaseComponent.prototype, "styles", void 0);

__decorate([Prop({
  type: Object,
  default: function _default() {
    return getTheme();
  }
}), __metadata("design:type", Object)], BaseComponent.prototype, "theme", void 0);

BaseComponent = __decorate([Component], BaseComponent);
var BaseComponent$1 = BaseComponent;

export default BaseComponent$1;
