import '../../../node_modules/core-js/modules/es.object.to-string.js';
import '../../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../../node_modules/core-js/modules/es.regexp.to-string.js';
import classCallCheck from '../../../node_modules/@babel/runtime/helpers/classCallCheck.js';
import createClass from '../../../node_modules/@babel/runtime/helpers/createClass.js';
import inherits from '../../../node_modules/@babel/runtime/helpers/inherits.js';
import possibleConstructorReturn from '../../../node_modules/@babel/runtime/helpers/possibleConstructorReturn.js';
import getPrototypeOf from '../../../node_modules/@babel/runtime/helpers/getPrototypeOf.js';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import '../../../node_modules/core-js/modules/es.symbol.js';
import '../../../node_modules/core-js/modules/es.array.filter.js';
import '../../../node_modules/core-js/modules/es.array.for-each.js';
import '../../../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../../../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../../../node_modules/core-js/modules/es.object.keys.js';
import '../../../node_modules/core-js/modules/web.dom-collections.for-each.js';
import defineProperty from '../../../node_modules/@babel/runtime/helpers/defineProperty.js';
import StatelessComponent from '../StatelessComponent.js';
import helper from '../../../node_modules/@vue/babel-helper-vue-jsx-merge-props/dist/helper.js';
import { getIconContent } from './FontIcon.js';
import { ImageLoadState } from '../Image/Image.types.js';
import '../Image/index.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction({
  // Icon is used a lot by other components.
  // It's likely to see expected cases which pass different className to the Icon.
  // Therefore setting a larger cache size.
  cacheSize: 100
});

var Icon = /*#__PURE__*/function (_StatelessComponent) {
  inherits(Icon, _StatelessComponent);

  var _super = _createSuper(Icon);

  function Icon() {
    classCallCheck(this, Icon);

    return _super.apply(this, arguments);
  }

  createClass(Icon, [{
    key: "render",
    value: function render(h, ctx) {
      var _ctx$props = ctx.props,
          className = _ctx$props.className,
          iconName = _ctx$props.iconName,
          theme = _ctx$props.theme,
          styles = _ctx$props.styles,
          imageErrorAs = _ctx$props.imageErrorAs;
      var isPlaceholder = typeof iconName === 'string' && iconName.length === 0;
      var isImage = !!ctx.props.imageProps;
      var iconContent = getIconContent(iconName) || {};
      var iconClassName = iconContent.iconClassName;
      var iconContentChildren = iconContent.children;
      var classNames = getClassNames(styles, {
        theme: theme,
        className: className,
        iconClassName: iconClassName,
        isImage: isImage,
        isPlaceholder: isPlaceholder
      });
      var RootType = isImage ? 'span' : 'i';
      var imageLoadError = false;

      var imageProps = _objectSpread(_objectSpread({}, ctx.props.imageProps), {}, {
        onLoadingStateChange: function onLoadingStateChange(state) {
          if (ctx.props.imageProps && ctx.props.imageProps.onLoadingStateChange) {
            ctx.props.imageProps.onLoadingStateChange(state);
          }

          if (state === ImageLoadState.error) {
            imageLoadError = true;
          }
        }
      });

      var ImageType = imageLoadError && imageErrorAs || Image;
      var ariaLabel = ctx.data.attrs && (ctx.data.attrs['aria-label'] || ctx.data.attrs.ariaLabel);
      var containerProps = ariaLabel ? {
        'aria-label': ariaLabel
      } : {
        'aria-hidden': !(ctx.props['aria-labelledby'] || imageProps['aria-labelledby'])
      };
      return h(RootType, helper([{
        "attrs": {
          "data-icon-name": iconName
        }
      }, _objectSpread(_objectSpread({}, ctx.data), {}, {
        props: containerProps
      }), {
        "class": classNames.root
      }]), [isImage // @ts-ignore
      ? h(ImageType, {
        "props": _objectSpread({}, imageProps)
      }) : ctx.scopedSlots.default && ctx.scopedSlots.default({}) || (typeof iconContentChildren === 'function' ? iconContentChildren(h) : iconContentChildren)]);
    }
  }]);

  return Icon;
}(StatelessComponent);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], Icon.prototype, "iconName", void 0);

__decorate([Prop({
  type: Object,
  default: null
}), __metadata("design:type", Object)], Icon.prototype, "imageProps", void 0);

__decorate([Prop({
  type: [String, Object],
  default: null
}), __metadata("design:type", Object)], Icon.prototype, "imageErrorAs", void 0);

Icon = __decorate([Component], Icon);
var Icon$1 = Icon;

export default Icon$1;
